-- frmSettings.lua
-- Written by Habna


function contextMenu()
	green = Turbine.UI.Color( 0, 0.77, 0 );
	white = Turbine.UI.Color( 1, 1, 1 );
	gray = Turbine.UI.Color( 0.5, 0.5, 0.5 );
	lightgray = Turbine.UI.Color(0.5, 0.3, 0.3, 0.3);
	black = Turbine.UI.Color();

	self = Turbine.UI.Lotro.Window()
	--self = Turbine.UI.Lotro.GoldWindow()
	
	-- **v Set backcolor, position, size and text of the window v**
	self:SetSize( 350, 340 );
	--local screenWidth, screenHeight = Turbine.UI.Display.GetSize()
	--local winWidth, winHeight = self:GetSize();
	--local left, top = ( screenWidth / 2 ) - ( winWidth / 2 ) , ( screenHeight / 2 ) - ( winHeight /2 )
    --self:SetPosition( left, top );
	self:SetPosition( WinLocX, WinLocY );
	self:SetText( "HugeBag contextual menu" );
	self:SetBackColor( Turbine.UI.Color() );
	self:SetVisible( true );
	--self:SetZOrder(1000);
	-- **^
	-- **v To create a new button v**
	local buttonClose = Turbine.UI.Lotro.Button();
	buttonClose:SetParent( self );
	buttonClose:SetPosition( 245, 305 );
	--buttonClose:SetSize( 75, 150 );
	buttonClose:SetWidth( 75 );
	buttonClose:SetText( "Close" );
	buttonClose:SetVisible( true );
	-- **^
	LoadListOptionsName()
	--**v Q Label v**
	local PosY = 40;
	for i = 1, 7 do
		local label1q = Turbine.UI.Label();
		label1q:SetParent( self );
		label1q:SetText( OptionNameList[i] );
		label1q:SetPosition( 15, PosY );
		label1q:SetSize( self:GetWidth(), 18 );
		label1q:SetForeColor( white );
		label1q:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		PosY = PosY + 20;
	end
	--**^
	--**v Show slots info in title v**
	local OptR1lbl = Turbine.UI.Label();
	OptR1lbl:SetParent( self );
	OptR1lbl:SetText( tostring( ShowSlotsInfo ) );
	OptR1lbl:SetPosition( 200, 40 );
	OptR1lbl:SetSize(35, 18 );
	OptR1lbl:SetForeColor( green );
	OptR1lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--**^
	--**v Slots info to show in title v**
	local OptR2lbl = Turbine.UI.Label();
	OptR2lbl:SetParent( self );
	if ToggleUsed then
		OptR2lbl:SetText( "used slots info" );
	else
		OptR2lbl:SetText( "free slots info" );
	end
	OptR2lbl:SetPosition( 220, 60 );
	OptR2lbl:SetSize(110, 18 );
	OptR2lbl:SetForeColor( green );
	OptR2lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--**^
	--**v Start visible at startup v**
	local OptR3lbl = Turbine.UI.Label();
	OptR3lbl:SetParent( self );
	OptR3lbl:SetText( tostring( StartVisible ) );
	OptR3lbl:SetPosition( 200, 80 );
	OptR3lbl:SetSize(35, 18 );
	OptR3lbl:SetForeColor( green );
	OptR3lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--**^
	--**v Hide HugeBag when 'esc' key is press v**
	local OptR4lbl = Turbine.UI.Label();
	OptR4lbl:SetParent( self );
	OptR4lbl:SetText( tostring( HideWEsc ) );
	OptR4lbl:SetPosition( 285, 100 );
	OptR4lbl:SetSize(35, 18 );
	OptR4lbl:SetForeColor( green );
	OptR4lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--**^
	--**v Size locker activated v**
	local OptR5lbl = Turbine.UI.Label();
	OptR5lbl:SetParent( self );
	OptR5lbl:SetText( tostring( LockSize ) );
	OptR5lbl:SetPosition( 175, 120 );
	OptR5lbl:SetSize(35, 18 );
	OptR5lbl:SetForeColor( green );
	OptR5lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--**^
	--**v Position locker activated v**
	local OptR6lbl = Turbine.UI.Label();
	OptR6lbl:SetParent( self );
	OptR6lbl:SetText( tostring( LockPosition ) );
	OptR6lbl:SetPosition( 205, 140 );
	OptR6lbl:SetSize(35, 18 );
	OptR6lbl:SetForeColor( green );
	OptR6lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--**^
	--**v Line v**
	local OptR7lbl = Turbine.UI.Label();
	OptR7lbl:SetParent( self );
	if ( Widget ) then
		OptR7lbl:SetText( "widget mode" );
	else
		OptR7lbl:SetText( "window mode" );
	end
	OptR7lbl:SetPosition( 115, 160 );
	OptR7lbl:SetSize(80, 18 );
	OptR7lbl:SetForeColor( green );
	OptR7lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--**^
	--**v Show free, used and max slots in shell v**
	local OptR8lbl = Turbine.UI.Label();
	OptR8lbl:SetParent( self );
	OptR8lbl:SetText( "Show Free, Used and Max slots in shell" );
	OptR8lbl:SetPosition( 15, 180 );
	OptR8lbl:SetSize(275, 18 );
	OptR8lbl:SetForeColor( green );
	OptR8lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--**^
	--**v Show free, used and max slots in shell v**
	local OptR9lbl = Turbine.UI.Label();
	OptR9lbl:SetParent( self );
	OptR9lbl:SetText( "Show HugeBag shell commands" );
	OptR9lbl:SetPosition( 15, 200 );
	OptR9lbl:SetSize(195, 18 );
	OptR9lbl:SetForeColor( green );
	OptR9lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--**^
	--**v Reset Location and size settings to default v**
	local OptR10lbl = Turbine.UI.Label();
	OptR10lbl:SetParent( self );
	OptR10lbl:SetText( "Reset Location and size settings to default" );
	OptR10lbl:SetPosition( 15, 220 );
	OptR10lbl:SetSize(310, 18 );
	OptR10lbl:SetForeColor( green );
	OptR10lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--**^
	--**v Reset all settings to default v**
	local OptR11lbl = Turbine.UI.Label();
	OptR11lbl:SetParent( self );
	OptR11lbl:SetText( "Reset all settings to default" );
	OptR11lbl:SetPosition( 15, 240 );
	OptR11lbl:SetSize(210, 18 );
	OptR11lbl:SetForeColor( green );
	OptR11lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--**^
	--**v Line v**
	local OptR12lbl = Turbine.UI.Label();
	OptR12lbl:SetParent( self );
	OptR12lbl:SetText( "Sort HugeBag items (Courtesy of MrJackdaw)" );
	OptR12lbl:SetPosition( 15, 260 );
	OptR12lbl:SetSize( 300, 18 );
	OptR12lbl:SetForeColor( green );
	OptR12lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--**^
	--**v Reset all settings to default v**
	local OptR13lbl = Turbine.UI.Label();
	OptR13lbl:SetParent( self );
	OptR13lbl:SetText( "Set HugeBag background color" );
	OptR13lbl:SetPosition( 15, 280 );
	OptR13lbl:SetSize(200, 18 );
	OptR13lbl:SetForeColor( green );
	OptR13lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--**^
	--**v Reset all settings to default v**
	local OptR14lbl = Turbine.UI.Label();
	OptR14lbl:SetParent( self );
	OptR14lbl:SetText( "About HugeBag" );
	OptR14lbl:SetPosition( 15, 300 );
	OptR14lbl:SetSize(95, 18 );
	OptR14lbl:SetForeColor( green );
	OptR14lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--**^
	--^ SETTINGS SECTION ^--
	--v EVENT HANDLERS SECTION v--
	-- **v Label click event v**
	OptR1lbl.MouseClick = function(sender, args)
		ToggleSlotsInfo()
		OptR1lbl:SetText( tostring( ShowSlotsInfo ) );
	end
	OptR2lbl.MouseClick = function(sender, args)
		ToggleFreeUsed()
		if ToggleUsed then
			OptR2lbl:SetText( "used slots info" );
		else
			OptR2lbl:SetText( "free slots info" );
		end
	end
	OptR3lbl.MouseClick = function(sender, args)
		ToggleShow()
		OptR3lbl:SetText( tostring( StartVisible ) );
	end
	OptR4lbl.MouseClick = function(sender, args)
		ToggleWEsc()
		OptR4lbl:SetText( tostring( HideWEsc ) );
	end
	OptR5lbl.MouseClick = function(sender, args)
		LockHugeBagSize()
		OptR5lbl:SetText( tostring( LockSize ) );
	end
	OptR6lbl.MouseClick = function(sender, args)
		LockHugeBagPosition()
		OptR6lbl:SetText( tostring( LockPosition ) );
	end
	OptR7lbl.MouseClick = function(sender, args)
		ToggleWidgetMode()
		self:Close();
	end
	OptR8lbl.MouseClick = function(sender, args)
		SlotsInfo()
	end
	OptR9lbl.MouseClick = function(sender, args)
		HelpInfo()
	end
	OptR10lbl.MouseClick = function(sender, args)
		ResetLSSettings()
		self:Close();
	end
	OptR11lbl.MouseClick = function(sender, args)
		ResetSettings()
		self:Close();
	end
	OptR12lbl.MouseClick = function(sender, args)
		SortHugeBag()
		self:Close();
	end
	OptR13lbl.MouseClick = function(sender, args)
		SetBackgroundColor()
	end
	OptR14lbl.MouseClick = function(sender, args)
		ShowAbout()
	end
	OptR1lbl.MouseHover = function(sender, args)
		OptR1lbl:SetBackColor( lightgray )
		OptR1lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
	end
	OptR1lbl.MouseLeave = function(sender, args)
		OptR1lbl:SetBackColor( black )
	end
	OptR2lbl.MouseHover = function(sender, args)
		OptR2lbl:SetBackColor( lightgray )
		OptR2lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
	end
	OptR2lbl.MouseLeave = function(sender, args)
		OptR2lbl:SetBackColor( black )
	end
	OptR3lbl.MouseHover = function(sender, args)
		OptR3lbl:SetBackColor( lightgray )
		OptR3lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
	end
	OptR3lbl.MouseLeave = function(sender, args)
		OptR3lbl:SetBackColor( black )
	end
	OptR4lbl.MouseHover = function(sender, args)
		OptR4lbl:SetBackColor( lightgray )
		OptR4lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
	end
	OptR4lbl.MouseLeave = function(sender, args)
		OptR4lbl:SetBackColor( black )
	end
	OptR5lbl.MouseHover = function(sender, args)
		OptR5lbl:SetBackColor( lightgray )
		OptR5lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
	end
	OptR5lbl.MouseLeave = function(sender, args)
		OptR5lbl:SetBackColor( black )
	end
	OptR6lbl.MouseHover = function(sender, args)
		OptR6lbl:SetBackColor( lightgray )
		OptR6lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
	end
	OptR6lbl.MouseLeave = function(sender, args)
		OptR6lbl:SetBackColor( black )
	end
	OptR7lbl.MouseHover = function(sender, args)
		OptR7lbl:SetBackColor( lightgray )
		OptR7lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
	end
	OptR7lbl.MouseLeave = function(sender, args)
		OptR7lbl:SetBackColor( black )
	end
	OptR8lbl.MouseHover = function(sender, args)
		OptR8lbl:SetBackColor( lightgray )
		OptR8lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
	end
	OptR8lbl.MouseLeave = function(sender, args)
		OptR8lbl:SetBackColor( black )
	end
	OptR9lbl.MouseHover = function(sender, args)
		OptR9lbl:SetBackColor( lightgray )
		OptR9lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
	end
	OptR9lbl.MouseLeave = function(sender, args)
		OptR9lbl:SetBackColor( black )
	end
	OptR10lbl.MouseHover = function(sender, args)
		OptR10lbl:SetBackColor( lightgray )
		OptR10lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
	end
	OptR10lbl.MouseLeave = function(sender, args)
		OptR10lbl:SetBackColor( black )
	end
	OptR11lbl.MouseHover = function(sender, args)
		OptR11lbl:SetBackColor( lightgray )
		OptR11lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
	end
	OptR11lbl.MouseLeave = function(sender, args)
		OptR11lbl:SetBackColor( black )
	end
	OptR12lbl.MouseHover = function(sender, args)
		OptR12lbl:SetBackColor( lightgray )
		OptR12lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
	end
	OptR12lbl.MouseLeave = function(sender, args)
		OptR12lbl:SetBackColor( black )
	end
	OptR13lbl.MouseHover = function(sender, args)
		OptR13lbl:SetBackColor( lightgray )
		OptR13lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
	end
	OptR13lbl.MouseLeave = function(sender, args)
		OptR13lbl:SetBackColor( black )
	end
	OptR14lbl.MouseHover = function(sender, args)
		OptR14lbl:SetBackColor( lightgray )
		OptR14lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
	end
	OptR14lbl.MouseLeave = function(sender, args)
		OptR14lbl:SetBackColor( black )
	end
	-- **^
	--**v Window event handlers v**
	-- **v Set the opacity when the mouse enter the window v**
	self.MouseEnter = function( sender, args )
		self:SetOpacity( 1.0 );
	end
	-- **^
	-- **v Set the opacity when the mouse leave the window v**
	self.MouseLeave = function( sender, args )
		self:SetOpacity( 1.0 );
	end

	self.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			self:SetVisible(false);
		end
	end

	-- **^
	--**^ Window event handlers ^**
	--**v Button event handlers v**
	-- **v Button click event v**
	buttonClose.Click = function(sender, args)
		self:Close();
	end
	-- **^
	--**^ Button event handlers ^**
	--^ EVENT HANDLERS SECTION ^--
end
-- **^