-- frmfunctions.lua
-- Written By Habna


-- **v Hide HugeBag v**
function ShowHugeBag()
	if ( frmMain:IsVisible() ) then
		write( "HugeBag: Impossible, I'm already visible" );
	else
		frmMain:SetVisible( true );
		--write( "HugeBag: I'm now visible" );
	end
end
-- **^
-- **v Hide HugeBag v**
function HideHugeBag()
	if ( not frmMain:IsVisible() ) then
		write( "HugeBag: Impossible, I'm already hidden" );
	else
		frmMain:SetVisible( false );
		--write( "HugeBag: I'm now hidden" );
	end
end
-- **^
-- **v Show Help Info v**
function UnloadHugeBag()
	--write( "HugeBag: Unloaded" );
	--Turbine.PluginManager.UnloadScriptState( "HugeBag" );
end
-- **^
-- **v Show Help Info v**
function ReloadHugeBag()
	--UnloadHugeBag()
	--LoadHugeBag()
end
-- **^
-- **v Toggle the ability to hide are not HugeBag when the 'esc' key is press v**
function ToggleWEsc()
	HideWEsc = ( not HideWEsc );
	SaveSettings()
	if ( HideWEsc ) then
		write( "HugeBag: I will hide when 'esc' key is press" );
	else
		write( "HugeBag: I will stay visible when 'esc' key is press" );
	end
end
-- **^
-- **v Toggle Startup Visibility v**
function ToggleShow()
	StartVisible = ( not StartVisible );
	SaveSettings()
	if ( StartVisible ) then
		write( "HugeBag: I will load visibile next time" );
	else
		write( "HugeBag: I will load hidden next time" );
	end
end
-- **^
-- **v Toggle to use widget mode are not v**
function ToggleWidgetMode()
	Widget = ( not Widget );
	SaveSettings()
	if ( Widget ) then
		write( "HugeBag: Will load in widget mode next time" );
	else
		write( "HugeBag: Will load in window mode next time" );
	end
end
-- **^
-- **v Show About window v**
function ShowAbout()
	import "HabnaPlugins.HugeBag.frmAbout"; -- LUA frmAbout file
	frmAbout()
end
-- **^
-- **v Set background color v**
function SetBackgroundColor()
	import "HabnaPlugins.HugeBag.frmOptions"; -- LUA frmOptions file
	frmOptions()
end
-- **^
-- **v Show Settings window v**
function ShowCurrentSettings()
	frmSettings()
end
-- **^
-- **v Show Version v**
function VersionInfo()
	write( "HugeBag: My current version is: v" .. Version );
end
-- **^
-- **v Show Authors v**
function AuthorsInfo()
	write( "HugeBag: My current authors are: Habna & Rod" );
end
-- **^
-- **v Show Shell Command window v**
function HelpInfo()
	import "HabnaPlugins.HugeBag.frmShellCmd"; -- LUA frmShellCmd file
	frmShellCmd()
end
-- **^
-- **v Show Slots Info v**
function SlotsInfo()
	local usedslots = backpackSize - freeslots;
	write( "HugeBag: I have " .. freeslots .. " free slots, " .. usedslots .. " used slots" ); -- and " .. backpackSize .. " max slots" );
end
-- **^
-- **v Toggle Slots Info to show free or used slots v**
function ToggleFreeUsed()
	ToggleUsed = ( not ToggleUsed );
	SaveSettings()
	frmMain:PrintTitle()
	if ( ToggleUsed ) then
		write( "HugeBag: Now showing used slots informations in the title" );
	else
		write( "HugeBag: Now showing free slots informations in the title" );
	end
end
-- **^
-- **v Toggle Slots Info v**
function ToggleSlotsInfo()
	ShowSlotsInfo = ( not ShowSlotsInfo );
	SaveSettings()
	frmMain:PrintTitle()
	if ( ShowSlotsInfo ) then
		write( "HugeBag: Now showing slots informations in the title" );
	else
		write( "HugeBag: Not showing slots informations in the title" );
	end
end
-- **^
-- **v Lock HugeBag Position v**
function LockHugeBagSize()
	LockSize = ( not LockSize );
	SaveSettings()
	if ( LockSize ) then
		write( "HugeBag: My size is now lock." );
	else
		write( "HugeBag: My size is now unlock." );
	end
end
-- **^
-- **v Lock HugeBag Position v**
function LockHugeBagPosition()
	LockPosition = ( not LockPosition );
	SaveSettings()
	if ( LockPosition ) then
		LockLabel:SetVisible( true );
		write( "HugeBag: My position is now lock." );
	else
		LockLabel:SetVisible( false );
		write( "HugeBag: My position is now unlock." );
	end
end
-- **^
-- **v Options List v**
function LoadListOptionsName()
	OptionNameList = {};
	OptionNameList[1]= "Show slots info in title: "
	OptionNameList[2]= "Slots info to show in title: "
	OptionNameList[3]= "Start visible at startup: "
	OptionNameList[4]= "Hide HugeBag when 'esc' key is press: "
	OptionNameList[5]= "Size locker activated: "
	OptionNameList[6]= "Position locker activated: "
	OptionNameList[7]= "HugeBag mode: "
end
-- **^
-- **v Shell command List v**
function LoadShellCommandName()
	ShellCommandName = {};
	ShellCommandName[1]= "show"
	ShellCommandName[2]= "hide"
	ShellCommandName[3]= "unload"
	ShellCommandName[4]= "reload"
	ShellCommandName[5]= "resetall"
	ShellCommandName[6]= "togglewesc"
	ShellCommandName[7]= "toggleshow"
	ShellCommandName[8]= "togglewidget"
	ShellCommandName[9]= "sort"
	ShellCommandName[10]= "about"
	ShellCommandName[11]= "curopt"
	ShellCommandName[12]= "version"
	ShellCommandName[13]= "authors"
	ShellCommandName[14]= "help/?"
	ShellCommandName[15]= "resetls"
	ShellCommandName[16]= "slotsinfo"
	ShellCommandName[17]= "toggleused"
	ShellCommandName[18]= "toggleslots"
	ShellCommandName[19]= "locksize"
	ShellCommandName[20]= "lockpos"
end
-- **^
--\nhelp/?: Show HugeBag shell commands" );	
-- **v Shell Command description list v**
function LoadShellCommandDes()
	ShellCommandDes = {};
	ShellCommandDes[1]= "Show HugeBag"
	ShellCommandDes[2]= "Hide HugeBag"
	ShellCommandDes[3]= "unload HugeBag (NOT WORKING)"
	ShellCommandDes[4]= "reload HugeBag (NOT WORKING)"
	ShellCommandDes[5]= "Reset all settings to default"
	ShellCommandDes[6]= "Toggle hide HugeBag event when the 'esc' key is press"
	ShellCommandDes[7]= "Show or hide HugeBag at startup"
	ShellCommandDes[8]= "Toggle between widget and window mode"
	ShellCommandDes[9]= "Sort HugeBag items (Courtesy of MrJackdaw)"
	ShellCommandDes[10]= "Show the 'About' window"
	ShellCommandDes[11]= "Show HugeBag 'Options'"
	ShellCommandDes[12]= "Show HugeBag version in shell"
	ShellCommandDes[13]= "Show HugeBag authors in shell"
	ShellCommandDes[14]= "Show HugeBag shell commands/?"
	ShellCommandDes[15]= "Reset location and size settings to default"
	ShellCommandDes[16]= "Show free, used and max slots in shell"
	ShellCommandDes[17]= "Toggle to show free or used slots info in title"
	ShellCommandDes[18]= "Show or hide slots information in title"
	ShellCommandDes[19]= "Lock/unlock HugeBag size"
	ShellCommandDes[20]= "Lock/unlock HugeBag position"
end

function SortHugeBag() -- Used Version 83 of SortBag
	VirtPack = {}
	for i = 1, backpackSize do
		VirtPack[i] = {}
		VirtPack[i].id = i
		item = frmMain.backpack:GetItem(i)
		if item ~= nil then
			VirtPack[i].Name = item:GetName()
		else
			VirtPack[i].Name = "zEmpty"
		end
	end

	for i = 1, backpackSize do
		VirtPack[i].Weight = weight(i)
	end

	--Sort VirtPack. If the weight of two items is the same compare the Names, after removing some characters. This way "2 Morale Potions" will get sorted with "Morale Potions"
	table.sort(VirtPack, function (a,b) 
		if a.Weight == b.Weight then
			return strip(a.Name) < strip(b.Name)
		else
			return (a.Weight < b.Weight)
		end
	end)

	Slot = 1;
	write("HugeBag: Sorting started") --("<rgb=#888888>Sort Started")
	Start= Turbine.Engine.GetGameTime()
	--FirstStart= Turbine.Engine.GetGameTime()
	sortCtr:SetWantsUpdates(true);
end

function strip(str)
	--Strip numbers first 7 characters to make the sort more logical
	local left=string.sub(str, 1, 7)
	local right=string.sub(str, 8)
	left=string.gsub(left,"[^%a]","")
	str= left .. right
	--Strip all spaces now!
	str=string.gsub(str,"[%s]","")
	return str
end

function swop(i,j)
	if frmMain.backpack:GetItem(j) == frmMain.backpack:GetItem(i) then return end
	
	item = frmMain.backpack:GetItem(j)

	if item ~= nil then
		frmMain.backpack:PerformItemDrop(item,i, false)
		return
	end
	
	item = frmMain.backpack:GetItem(i)

	if item ~= nil then
		frmMain.backpack:PerformItemDrop(item,j, false)
		return
	end
	
	write( "Should never be seen. Error in Swop function." )
	--write("<rgb=#888888>Should never be seen. Error in Swop function.")
	--sortCtr:SetWantsUpdates(false)
	--SortHugeBag()
end

function weight(i)
	item = frmMain.backpack:GetItem(i)
	if item == nil then
		--Empty slots have no name, quality, category etc
		Name = 0
		Category = 0
		Quality = 0
	else
		Name = item:GetName()
		Category = item:GetCategory()
		Quality = item:GetQuality()
		if Quality == nil then Quality = 0 end
	end
	
	--Calculate the weight
	local Weight = 0
	
	CategoryText = ItemCategory[Category]
	if CategoryText ~= nil then					
		CatWeight = value[CategoryText]		--First scan the CategoryText using the value table Note:This will bug out if Turbine add any new item categories!
	else
		--This item has not been given a category number by turbine - it is missing from the category text list.
		write( Name.." has not been given category text by Turbine. Dammit. It's number is "..Category.." Please inform MrJackdaw!" )
	end
	
	QualWeight = Quality
	
	Weight = CatWeight * 10 + QualWeight
	
	if item == nil then Weight = 99999 end
	
	return Weight
end

function mergetable(table1,list)
	--Appends tables from list on the end of table1
	for i=1,#list do
		table2=list[i]
		local LenTable1=#table1
		for a =LenTable1+1,#table1+#table2 do
			table1[a]=table2[a-LenTable1]
		end
	end
end
-- **^